//
//  DrumGeneratorViewController.h
//
//  Created by Steffan Walters on 02/01/2013.
//  Copyright (c) 2013 Steffan Walters. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>

//UICollectionView tutorial:http://www.adoptioncurve.net/archives/2012/09/a-simple-uicollectionview-tutorial.php

@interface DrumGeneratorViewController : UIViewController <UITableViewDataSource, UITableViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout>

/*START IBOUTLETS*/
@property (strong, nonatomic) IBOutlet UICollectionView *cvDrumGrid;    //drum grid (uicollectionview outlet)

@property (strong, nonatomic) IBOutlet UITableView *tvFiles;   //table for saved files
@property (strong, nonatomic) IBOutlet UITextField *tfTextSaveFile;   //save file name

@property (strong, nonatomic) IBOutlet UISlider *sliDrum1Vol;   //drum 1 volume slider
@property (strong, nonatomic) IBOutlet UISlider *sliDrum2Vol;   //drum 2 volume slider

@property (strong, nonatomic) IBOutlet UITextField *tfBPM;  //BPM text field
@property (strong, nonatomic) IBOutlet UIButton *btnLoadFile;   //load button
@property (strong, nonatomic) IBOutlet UIButton *btnDeleteFile; //delete button

@property (strong, nonatomic) IBOutlet UIButton *btnPlay;   //play button
@property (strong, nonatomic) IBOutlet UIButton *btnStop;   //stop button

/*END IBOUTLETS*/


/*START IBACTIONS*/
- (IBAction)actionTestDrum1:(id)sender;   //test the sound of drum 1
- (IBAction)actionTestDrum2:(id)sender;   //test the sound of drum 2

//Play/Stop/Reset drum grid methods
- (IBAction)actionPlayDrums:(id)sender;     //Play drums action
- (IBAction)actionStopDrums:(id)sender;     //Stops the drums from playing - breaks the infinite loop
- (IBAction)actionResetGrid:(id)sender;     //Reset the drum grid action

- (IBAction)actionDeleteFile:(id)sender;    //Delete file action
- (IBAction)actionSaveFile:(id)sender;      //Save file action
- (IBAction)actionLoadFile:(id)sender;      //Load file action

- (IBAction)actionBPM:(id)sender;             //action to retrieve the value for bpm
- (IBAction)actionDrum1Volume:(id)sender;     //set volume for the drum player
- (IBAction)actionDrum2Volume:(id)sender;     //set volume for the drum player
/*END IBACTIONS*/

//Redundant methods
- (IBAction)printTemo:(id)sender;   //Print values of drum array - reduntant final version


@end
